#ifndef _CARTE_HPP_
#define _CARTE_HPP_


#include "util.h"
#include "ueib.h"
#include "other.hpp"
#include "param.h"
#include <sstream>

// K8055 ana input
#define INP_TEMP 0 // temperature captor
#define INP_TEMP_CARD 0 // temperature captor


// insert error type in table error + log
void insert_error(connexion &c,short type);


class K8055
{
private:
  ueib_handle *uh1;
ueib_handle *uh2;
connexion co;
config cfg;
short card1_address;
short card2_address;
bool presente;

public:

  K8055(connexion &,config &, bool);
  ~K8055();
  void init ();
  void maj ();
  void arret();
  short change_state(short,short,short,string);
void change_state_mail(short,short,short,string);
  void print_status();
  int read(int bit,int);
  short resetcounter(int,int);
int readAnalog(int,int);
int readcounter(int,int);
};




#endif


