/*
  Name : peristatic.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a peristatic pump
*/

#ifndef _PERISTATIC_HPP_
#define _PERISTATIC_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Peristatic:public Objet
{
private:
 string nb; // used for printing nb of pump (1->4)
  void forceState(short,K8055 &,config &);	//force the state of the peristatic pump
  void changeState (short,K8055 &,config &);//change the state of the peristatic pump
public:
  Peristatic(string n){nb=n;init();}
  void init();

  
  short get_State(string,connexion  &);// getting state of peristatic pump (depends of 5 time elapses)
  void changing(short st,K8055&,config&);//check the state of the peristatic pump
};


#endif
