#ifndef _CPHIDGET_MACROS
#define _CPHIDGET_MACROS

#define IFIRE(s, ename, ...) (((s)->fptr##ename##Change) ? \
	(s)->fptr##ename##Change((s), (s)->fptr##ename##Changeptr, \
	__VA_ARGS__) : 0)

#define DPRINT_PHIDGET(phid) ((phid) ? DPRINT("phid %p 0x%x/%x,%x %s#%d", \
    (phid), (phid)->VendorID, (phid)->ProductID, (phid)->status, \
    (phid)->deviceType ? (phid)->deviceType : "unknown", (phid)->serialNumber) \
    : 0)

#define PINTEGER int
#define PDOUBLE double
//#define PFLOAT float

#define PFHANDLE(pname)	CPhidget##pname##Handle
#define PHANDLE(pname) CPhidget##pname##Handle 
#define EXTERN 

#define DPHANDLE(pname) typedef struct _CPhidget##pname __CPhidget##pname; \
	typedef __CPhidget##pname *CPhidget##pname##Handle;

#define CHDRSTANDARD(pname) PHIDGET21_API int CCONV CPhidget##pname##_create(CPhidget##pname##Handle *);

#define CHDRREAD(pname)

#define CHDREVENTINDEX(pname,ename,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set_On##ename##_Handler(PHANDLE(pname), int (CCONV *fptr)(PFHANDLE(pname), void *, int, proptype), void *);
#define CHDREVENTINDEX2(pname,ename,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set_On##ename##_Handler(PHANDLE(pname), int (__cdecl *fptr)(PFHANDLE(pname), void *, int, proptype), void *);
#define CHDREVENT(pname,ename,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set_On##ename##_Handler(PHANDLE(pname), int (CCONV *fptr)(PFHANDLE(pname), void *, proptype), void *);

#define CHDRGET(pname,propname,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_get##propname(PHANDLE(pname), proptype *pVal); 
#define CHDRSET(pname,propname,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set##propname(PHANDLE(pname), proptype newVal); 

#define CHDRGETINDEX(pname,propname,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_get##propname(PHANDLE(pname), int Index, proptype *pVal); 
#define CHDRSETINDEX(pname,propname,proptype) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set##propname(PHANDLE(pname), int Index, proptype newVal); 

#define CHDRGETSETINDEX(pname,propname,proptype) CHDRGETINDEX(pname,propname,proptype) \
CHDRSETINDEX(pname,propname,proptype) 
#define CHDRGETSET(pname,propname,proptype) CHDRGET(pname,propname,proptype) \
CHDRSET(pname,propname,proptype) 


#define TESTPTR(phidname) { if (!phidname) return EPHIDGET_INVALIDARG; }
#define TESTPTRS(vname1,vname2) { if ((!vname1) || (!vname2)) return EPHIDGET_INVALIDARG; }
#define TESTRNG1(vname1) { if (Index >= phid->vname1) return EPHIDGET_INVALIDARG; }
#define MASGN(vname1) { *pVal = phid->vname1; return EPHIDGET_OK; }
#define MASGN1(vname1) { *pVal = phid->vname1; return EPHIDGET_OK; }
#define ASGNFPTR(pname, vname1) { CPhidget##pname##Info *phid = (CPhidget##pname##Info *)phidA; TESTPTR(phid); phid->fptr##vname1##Change = fptr; phid->fptr##vname1##Changeptr = userPtr; return EPHIDGET_OK; }


#define CFHANDLE(pname,param) \
	EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set_On##param##Change_Handler(CPhidget##pname##Handle phidA, int (CCONV *fptr)(CPhidget##pname##Handle, void *, 

#define CFHANDLE2(pname,param) \
	EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set_On##param##Change_Handler(CPhidget##pname##Handle phidA, int (__cdecl *fptr)(CPhidget##pname##Handle, void *, 


#define CPHIDGETDATA(pname) EXTERN PHIDGET21_API int CCONV CPhidget##pname##_dataInput(CPhidgetHandle phidG, unsigned char *buffer, int length) \
{ \
	CPhidget##pname##Handle phid = (CPhidget##pname##Handle)phidG;

#define FIRE(ename) if (phid->fptr##ename##Change) phid->fptr##ename##Change(phid, phid->fptr##ename##Changeptr, 

#define CGETINDEX(pname,propname,proptype) \
EXTERN PHIDGET21_API int CCONV CPhidget##pname##_get##propname(CPhidget##pname##Handle phid, int Index, proptype *pVal) { 

#define CGET(pname,propname,proptype) \
EXTERN PHIDGET21_API int CCONV CPhidget##pname##_get##propname(CPhidget##pname##Handle phid, proptype *pVal) {

#define CSETINDEX(pname,propname,proptype) \
EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set##propname(CPhidget##pname##Handle phid, int Index, proptype newVal) { 

#define CSET(pname,propname,proptype) \
EXTERN PHIDGET21_API int CCONV CPhidget##pname##_set##propname(CPhidget##pname##Handle phid, proptype newVal) { 


#define CPHIDGETINIT(pname) \
int CCONV CPhidget##pname##_initAfterOpen(CPhidgetHandle phidG, \
    unsigned char *buffer, int length) \
{ \
	CPhidget##pname##Handle phid = (CPhidget##pname##Handle)phidG;

#define CMAKEPACKET(pname, buffer, lenp) \
static int CCONV CPhidget##pname##_makePacket(CPhidgetHandle phidG, \
    unsigned char *buffer, unsigned int *lenp) \
{

#define CSENDPACKET_BUF(pname, buffer, buflen) \
static int CCONV _sendpacket(CPhidget##pname##Handle phid, \
    const unsigned char *buf, unsigned int len) \
{ \
again: \
	if (!CPhidget_isAttached(&phid->phid)) \
		return EPHIDGET_NOTATTACHED; \
	CThread_mutex_lock(&phid->phid.outputLock); \
	if (phid->buflen) { \
		CThread_mutex_unlock(&phid->phid.outputLock); \
		CThread_wait_on_event(&phid->phid.writtenEvent, INFINITE); \
		goto again; \
	} \
	memcpy(phid->buffer, buf, len); \
	phid->buflen = len; \
	CThread_reset_event(&phid->phid.writtenEvent); \
	CThread_mutex_unlock(&phid->phid.outputLock); \
	CThread_set_event(&phid->phid.writeAvailableEvent); \
	return 0; \
}

#define CMAKEPACKET_BUF(pname, buffer, buflen) \
static int CCONV CPhidget##pname##_makePacket(CPhidgetHandle phidG, \
    unsigned char *buf, unsigned int *lenp) \
{ \
	CPhidget##pname##Handle phid = (CPhidget##pname##Handle)phidG; \
	CThread_mutex_lock(&phid->phid.outputLock); \
	if (*lenp < phid->buflen) { \
		CThread_mutex_unlock(&phid->phid.outputLock); \
		return EPHIDGET_INVALIDARG; \
	} \
	memcpy(buf, phid->buffer, *lenp = phid->buflen); \
	phid->buflen = 0; \
	CThread_mutex_unlock(&phid->phid.outputLock); \
	return EPHIDGET_OK; \
}

#define CCREATE(pname,pdef) int CCONV CPhidget##pname##_create(CPhidget##pname##Handle *phidp) \
{ \
	CPhidget##pname##Handle phid; \
	if (!phidp) \
		return EPHIDGET_INVALIDARG; \
	if (!(phid = (CPhidget##pname##Handle)malloc(sizeof (*phid)))) \
		return EPHIDGET_NOMEMORY; \
	ZEROMEM(phid, sizeof(*phid)); \
	phid->phid.deviceID = pdef; \
	phid->phid.fptrInit = CPhidget##pname##_initAfterOpen; \
	phid->phid.fptrData = CPhidget##pname##_dataInput; \
	phid->phid.fptrMakePacket = CPhidget##pname##_makePacket; \
	CThread_mutex_init(&phid->phid.lock); \
	CThread_mutex_init(&phid->phid.writelock); \
	CThread_mutex_init(&phid->phid.outputLock); \
	CPhidget_setStatus(&phid->phid, PHIDGET_NOTATTACHED); \
	CThread_create_event(&phid->phid.writeAvailableEvent); \
	CThread_create_event(&phid->phid.writtenEvent); \
	*phidp = phid; \
	return EPHIDGET_OK; \
}

#define ADDNETWORKKEYINDEXED(kname, valType) \
{ \
	char key[1024], val[1024]; \
	if(!CPhidgetSocketClient_isAttached(phid->phid.networkInfo)) \
		return EPHIDGET_NETWORK_NOTCONNECTED; \
	snprintf(key, sizeof(key), "/PCK/%s/%d/" #kname "/%d", phid->phid.deviceType, phid->phid.serialNumber, Index); \
	snprintf(val, sizeof(val), valType, newVal); \
	pdc_async_set(phid->phid.networkInfo->pdcs, key, val, PFALSE, internal_async_network_error_handler, &phid->phid); \
}

#define ADDNETWORKKEY(kname, valType) \
{ \
	char key[1024], val[1024]; \
	if(!CPhidgetSocketClient_isAttached(phid->phid.networkInfo)) \
		return EPHIDGET_NETWORK_NOTCONNECTED; \
	snprintf(key, sizeof(key), "/PCK/%s/%d/" #kname , phid->phid.deviceType, phid->phid.serialNumber); \
	snprintf(val, sizeof(val), valType, newVal); \
	pdc_async_set(phid->phid.networkInfo->pdcs, key, val, PFALSE, internal_async_network_error_handler, &phid->phid); \
}

#endif
