#ifndef __CPHIDGETPHSENSOR
#define __CPHIDGETPHSENSOR


DPHANDLE(PHSensor)

CHDRSTANDARD(PHSensor)
CHDRGET(PHSensor,PH,PDOUBLE)
CHDRGET(PHSensor,Potential,PDOUBLE)
CHDRGETSET(PHSensor,PHChangeTrigger,PDOUBLE)
CHDREVENT(PHSensor,PHChange,PDOUBLE)


#ifndef EXTERNALPROTO
struct _CPhidgetPHSensor {
	CPhidget phid;


	int (CCONV *fptrPHChange)(CPhidgetPHSensorHandle, void *, double);

	void *fptrPHChangeptr;

	double PH, Potential;
	double lastPH;
	double PHChangeTrigger;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;


} typedef CPhidgetPHSensorInfo;
#endif


#endif
