#ifndef __CPHIDGETRFID
#define __CPHIDGETRFID



DPHANDLE(RFID)
CHDRSTANDARD(RFID)
CHDRGET(RFID,NumOutputs,PINTEGER)
CHDRGETSETINDEX(RFID,OutputState,PINTEGER)
CHDRGETSET(RFID,AntennaOn,PINTEGER)
CHDRGETSET(RFID,LEDOn,PINTEGER)

CHDREVENTINDEX(RFID,OutputChange,PINTEGER)


EXTERN PHIDGET21_API int CCONV CPhidgetRFID_getLastTag(PHANDLE(RFID), unsigned char *pVal);
EXTERN PHIDGET21_API int CCONV CPhidgetRFID_set_OnTag_Handler(PHANDLE(RFID), int (CCONV *fptr)(PFHANDLE(RFID), void *, unsigned char *), void *);
EXTERN PHIDGET21_API int CCONV CPhidgetRFID_set_OnTagLost_Handler(PHANDLE(RFID), int (CCONV *fptr)(PFHANDLE(RFID), void *, unsigned char *), void *);


#ifndef EXTERNALPROTO
#define RFID_MAXOUTPUTS 4
struct _CPhidgetRFID {
	CPhidget phid;

	int (CCONV *fptrOutputChange)(CPhidgetRFIDHandle, void *, int, int);           
	void *fptrOutputChangeptr;
	int (CCONV *fptrTag)        (CPhidgetRFIDHandle, void *, unsigned char *); 
	void *fptrTagptr;
	int (CCONV *fptrTagLost)        (CPhidgetRFIDHandle, void *, unsigned char *); 
	void *fptrTagLostptr;
	unsigned char outputStates[RFID_MAXOUTPUTS];
	unsigned char outputEchoStates[RFID_MAXOUTPUTS];		// Values returned from the device

	unsigned char lastTag[10];

	char	fullStateEcho;
	int		tagPresent;
	TIME	lastTagTime;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;

} typedef CPhidgetRFIDInfo;
#endif


#endif
