<? 

// insertion du fichier de configuration du site
require '../../config/config.php';
require '../../config/objConnect.php';
require '../../Artichow/LinePlot.class.php';

//connexion  la base de donnes
$oConnection = new Connection($dConfig['connection']);
$oConnection -> start();


// construction du graphique
$graph = new Graph(800, 300);
$graph->setAntiAliasing(TRUE);

$green = new Color(125, 250, 0);
$red = new Color(200, 0, 0);
$blue = new Color(0, 0, 150, 20);


$group = new PlotGroup;
$group->grid->setType(LINE_DASHED);
// Set a background gradient
$group->setBackgroundGradient(
	new LinearGradient(
		new Color(210, 210, 210),
		new Color(255, 255, 255),
		0
	)
);

$group->setPadding(40, 40, 20, 40);
$group->axis->left->title->set("Temperature");
$group->axis->left->setTickStyle(TICK_OUT);
$group->axis->right->title->set("Ph");
$group->axis->right->setTickStyle(TICK_OUT);



//************************************************************************************************************
$rep = mysql_query("SELECT * FROM temperature WHERE nom='day' AND i <= 23 AND i> HOUR(NOW()) ORDER BY i") or die('Erreur SQL !<br>'.mysql_error());
while ($resu = mysql_fetch_array($rep)) // on lit une r&eacute;ponse
    {
          $x2[]=$resu["t"];
	  $e[]=	$resu["i"];		
    }

$rep = mysql_query("SELECT * FROM temperature WHERE nom='day' AND i <= HOUR(NOW()) ORDER BY i") or die('Erreur SQL !<br>'.mysql_error());
while ($resu = mysql_fetch_array($rep)) // on lit une r&eacute;ponse
    {
          $x2[]=$resu["t"];			
	  $e[]=	$resu["i"];	
    }
	
$rep = mysql_query("SELECT * FROM ph WHERE nom='day' AND i <= 23 AND i> HOUR(NOW()) ORDER BY i") or die('Erreur SQL !<br>'.mysql_error());
while ($resu = mysql_fetch_array($rep)) // on lit une r&eacute;ponse
    {
          $x2ph[]=$resu["t"];
	  $eph[]=	$resu["i"];		
    }

$rep = mysql_query("SELECT * FROM ph WHERE nom='day' AND i <= HOUR(NOW()) ORDER BY i") or die('Erreur SQL !<br>'.mysql_error());
while ($resu = mysql_fetch_array($rep)) // on lit une r&eacute;ponse
    {
          $x2ph[]=$resu["t"];			
	  $eph[]=	$resu["i"];	
	  }
//**************************************************************************************************************	
	
	
$min=min($x2)-3;
$max=max($x2)+2;
$minph=min($x2ph)-1;
$maxph=max($x2ph)+2;


for($i=0;$i<24;$i++) 
	{
	$x[$i]=$x2[$i]-$min;
	$xph[$i]=$x2ph[$i]-$minph;
	}
	


$plot = new LinePlot($x);

// Change line color
$plot->setColor($blue);


// Change mark type
$plot->mark->setType(MARK_STAR);
$plot->mark->border->show();
$plot->label->set($x2);
$plot->label->move(0, -23);
$plot->label->setBackgroundGradient(
	new LinearGradient(
		new Color(250, 250, 250, 10),
		new Color(255, 200, 200, 30),
		0
	)
);
$plot->label->border->setColor(new Color(20, 20, 20, 20));
$plot->label->setPadding(3, 1, 1, 0);
$plot->setXAxisZero(FALSE);
$group->legend->add($plot, "t", LEGEND_MARK);
$group->add($plot);

//*************************************************************
$plot = new LinePlot($xph);

// Change line color
$plot->setColor($red);


// Change mark type
$plot->mark->setType(MARK_CIRCLE);
$plot->mark->border->show();
$plot->label->set($x2ph);
$plot->label->move(0, -23);
$plot->label->setBackgroundGradient(
	new LinearGradient(
		new Color(250, 250, 250, 10),
		new Color(255, 200, 200, 30),
		0
	)
);
$plot->label->border->setColor(new Color(20, 20, 20, 20));
$plot->label->setPadding(3, 1, 1, 0);
$plot->setXAxisZero(FALSE);
$plot->setYAxis(PLOT_RIGHT);
$plot->yAxis->setColor($red);

$group->legend->add($plot, "ph", LEGEND_MARK);
$group->add($plot);

//*************************************************************


$graph->shadow->setSize(4);
$graph->shadow->setPosition(SHADOW_RIGHT_BOTTOM);
$graph->shadow->smooth(TRUE);

$group->axis->bottom->title->set("Heure");
$group->axis->bottom->setTitleAlignment(1);


$group->axis->bottom->setLabelText($e);



$group->setYmax($max-$min);
function sett($value) {
	global $min;
	$r=(int)($value+$min);
	return $r;
}

function sett2($value) {
	global $minph;
	$r=(int)($value+$minph);
	return $r;
}


$group->axis->left->label->setCallbackFunction('sett');
$group->axis->left->setColor($blue);
$group->axis->right->label->setCallbackFunction('sett2');
$group->axis->right->setColor($red);

$graph->add($group);
$graph->draw();
?>
