/*
  Name : configuration.hpp
  Copyright : KPAMEGAN & ROUSSET
  Authors : KPAMEGAN Karel, ROUSSET Baptiste
  Description: file which contents functions to display acquisitions on a LCD screen
*/

#ifndef _acquisition_h_
#define _acquisition_h_

#include "base.hpp"
#include "effect.hpp"

class Configuration : public Screen
{
private :
  char *param1;                            //value of the first parameter
  char *param2;                            //value of the second parameter
  char *param3;                            //value of the third parameter
  char *param4;                            //value of the last parameter

public :
  Configuration(char *name1="NULL",char *name2="NULL",char *name3="NULL",char *name4="NULL");  //this is a constructor
  Configuration(int i);                    //this is a constructor
  ~Configuration();                        //this is the destructor
  void set_param1(char *name);             //set the name of a pamater on the screen
  void set_param2(char *name);             //set the name of a pamater on the screen
  void set_param3(char *name);             //set the name of a pamater on the screen
  void set_param4(char *name);             //set the name of a pamater on the screen

  void set_param1_value(char *val);        //set the value of a pamater on the screen
  void set_param2_value(char *val);        //set the value of a pamater on the screen
  void set_param3_value(char *val);        //set the value of a pamater on the screen
  void set_param4_value(char *val);        //set the value of a pamater on the screen
  
  void clean_param_value(int nop);         //delete the value of a param
  void clean_param_name(int nop);          //delete the name of a param

};

#endif
