/*
  Name : initTimer.hpp
  Copyright : KPAMEGAN & ROUSSET
  Authors : KPAMEGAN Karel, ROUSSET Baptiste
  Description: file which contents parameters of the screens ( times, ... )
*/

#ifndef _INIT_TIMER_HPP_
#define _INIT_TIMER_HPP_

class InitTimes
{
private:
  int timeInterScreen;			           //time between two screens
  int numberBlinkTitle;			           //number of blink of the alert title
  bool logs;                                       //state if we want to display logs or not
  
public:
  InitTimes(int time,int number,bool log);	   //initialize the times between two screens and the number of blink of the alert title
  ~InitTimes(void);                                //this is the destructor
  void set_timeInterScreen(int time);	           //set the time between two Screen
  void set_numberBlinkTitle(int number);           //set the number of blink
  void set_state_log(bool state);                  //set the bool of the logs
  int get_timeInterScreen(void);	           //get the time between two Screen
  int get_numberBlinkTitle(void);	           //get the number of blink
  bool get_bool_log(void);                         //get the bool of the logs
};

#endif
