#include "includes/peristatic.hpp"

void Peristatic::init()
{
  state=0;
  state_sauv=0;
}

void Peristatic::forceState(short forcedState,K8055 &k,config &cfg)
{
int i;

i=atoi(nb.c_str()); 
 if (forcedState!=state)
    {
      state_sauv=state;
    	
      state=forcedState;
      k.change_state(cfg.OUTPERI[i],cfg.OUTPERI_CARD[i],state,"pompe doseuse "+nb+ "forcee");
    }
}

void Peristatic::changeState (short state,K8055 &k,config &cfg)
{
int i;

i=atoi(nb.c_str())-1; 

  this->state=state;
  state_sauv=state;
  k.change_state(cfg.OUTPERI[i],cfg.OUTPERI_CARD[i],state,"pompe doseuse "+nb);
}


short Peristatic::get_State(string s,connexion  &c)
{
  temps t,tbegin,tend;
  bool button,b;
  bool r[5];
  short i;
  param p;
niterations++;

if (niterations==5)
{
  t.set_current_time();
//for all hour plages
  for(i=0;i<3;i++)
    {
      try{c.get_parameter(s,p,i+1);}
	catch(exception& er) { return state;} // erreur d'acces  la base pb acces concurrent ?
      tbegin.set_time(p.get_init_timer());
      tend.set_time(p.get_end_timer());
      button=p.get_button();
      b=t.inclus(tbegin,tend);
      if(b==true && button==true) r[i]=true;
      if(b==true && button==false) r[i]=false;
      if(b==false) r[i]=false;
		
    }
  niterations=0;  
  if ((r[0]||r[1]||r[2])==true) return 1; else return 0;
}
else return state;
}


void Peristatic::changing(short st,K8055&k,config&cfg)
{
int i;

i=atoi(nb.c_str())-1;

  if(cfg.forced_peri[i]!=0) 
    forceState(cfg.forced_peri[i]-1,k,cfg);
  else
    {
      if (state!=state_sauv)
    	changeState(state_sauv,k,cfg);
      if (state!=st )
	changeState(st,k,cfg);
    }
}
