#include "includes/phsonde.hpp"

void phsonde::init() {
n=0;
ph=0.0;
error_ph=false;
first_error=true;
correction=0;
CPhidgetPHSensor_create(&ifkit); 
CPhidget_open((CPhidget*)ifkit, -1);
//CPhidget_waitForAttachment ((CPhidget*)ifkit, 1000);
//CPhidget_getDeviceStatus ((CPhidget*)ifkit,&status);
//cout << status<< endl;

    }



double phsonde::read_ph(connexion &c)
                {
int status;
                if (n == 0) {
 		               CPhidget_getDeviceStatus ((CPhidget*)ifkit,&status);
					if (status ==0) 
              		   {error_ph=true;ph=0;
				   if (first_error==true) {c.insert_log("erreur lecture ph");first_error=false;}
					}
                            else {    
					calibrez(c);
					error_ph=false;
                    			first_error=true;
					CPhidgetPHSensor_getPH(ifkit,&ph);
					ph=ph+correction;
					if (DEBUG == 1) cout << "ph: " << ph << "calibration: " << correction <<  endl;
					
				       c.insert_current_ph(ph);
					}	                     
       			}     
		n++;
		if (n==25) n=0;
return ph;   
         }
// calibrer sonde
void phsonde::calibrez(connexion &c)
    {
        double lecture=0;
        double p=0;

        p = c.calibre_ph();
        if (p!=0)
        {
	       if (DEBUG == 1) cout << "calibrage ph" << endl;
	       CPhidgetPHSensor_getPH(ifkit,&lecture);
               correction=p-lecture;
      	       c.set_calibre(correction);
	}		            
}

double phsonde::get_ph() {
                    
                    return ph+correction;
                
                }

bool phsonde::get_error() {return error_ph;}
void phsonde::set_first_error(bool b) {first_error=b;}
bool phsonde::get_first_error(){return first_error;}
void phsonde::set_correction(double d) {correction=d;}
double phsonde::get_correction() {return correction;}

phsonde:: ~phsonde()
{
CPhidget_close ((CPhidget*)ifkit);
}
