#ifndef __CPHIDGETADVANCEDSERVO
#define __CPHIDGETADVANCEDSERVO


DPHANDLE(AdvancedServo)

CHDRSTANDARD(AdvancedServo)
CHDRGET(AdvancedServo,NumMotors,PINTEGER)
CHDRGETSETINDEX(AdvancedServo,Acceleration,PDOUBLE)
CHDRGETSETINDEX(AdvancedServo,MaxVelocity,PDOUBLE)
CHDRGETSETINDEX(AdvancedServo,MotorPosition,PDOUBLE)
CHDRGETINDEX(AdvancedServo,Current,PDOUBLE)
CHDREVENTINDEX(AdvancedServo,PositionChange,PDOUBLE)


#ifndef EXTERNALPROTO
#define ADVSERVO_MAXSERVOS 8
struct _CPhidgetAdvancedServo {
	CPhidget phid;

	int (CCONV *fptrPositionChange)(CPhidgetAdvancedServoHandle, void *, int, double);           

	void *fptrPositionChangeptr;
	double motorPWMCurrent[ADVSERVO_MAXSERVOS];
	double motorSensedCurrent[ADVSERVO_MAXSERVOS];

	double motorPWMDesired[ADVSERVO_MAXSERVOS];
	double motorAcceleration[ADVSERVO_MAXSERVOS];
	double motorMaxVelocity[ADVSERVO_MAXSERVOS];

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;
} typedef CPhidgetAdvancedServoInfo;
#endif

#endif
