#ifndef __CPHIDGETTEXTLCD
#define __CPHIDGETTEXTLCD

DPHANDLE(TextLCD)

CHDRSTANDARD(TextLCD)
CHDRGET(TextLCD,NumRows,PINTEGER)
CHDRGET(TextLCD,NumColumns,PINTEGER)
CHDRGETSET(TextLCD,Backlight,PINTEGER)
CHDRGETSET(TextLCD,Contrast,PINTEGER)
CHDRGETSET(TextLCD,CursorOn,PINTEGER)
CHDRGETSET(TextLCD,CursorBlink,PINTEGER)

EXTERN PHIDGET21_API int CCONV CPhidgetTextLCD_setCustomCharacter (PHANDLE(TextLCD), int Index, int Val1, int Val2);

EXTERN PHIDGET21_API int CCONV CPhidgetTextLCD_setDisplayString(PHANDLE(TextLCD), int Row, char *displayString);

#ifndef EXTERNALPROTO
#define TEXTLCD_MAXROWS 2
#define TEXTLCD_MAXCOLS 20
struct _CPhidgetTextLCD {
	CPhidget phid;

	unsigned char m_blnCursorOn,m_blnCursorBlink,m_blnBacklight;
	unsigned char m_iContrast;

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;

} typedef CPhidgetTextLCDInfo;
#endif


#endif
